{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Graf.TView3D.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Graf.TView3D.RawType
import HROOT.Graf.TView3D.FFI
import HROOT.Graf.TView3D.Interface
import HROOT.Graf.TView3D.Cast
import HROOT.Graf.TView3D.RawType
import HROOT.Graf.TView3D.Cast
import HROOT.Graf.TView3D.Interface
import HROOT.Core.TVirtualPad.RawType
import HROOT.Core.TVirtualPad.Cast
import HROOT.Core.TVirtualPad.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Graf.TView.RawType
import HROOT.Graf.TView.Cast
import HROOT.Graf.TView.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITView3D (TView3D) where

instance () => ITView (TView3D) where
        front = xform0 c_tview3d_front
        frontView = xform1 c_tview3d_frontview
        getLatitude = xform0 c_tview3d_getlatitude
        getLongitude = xform0 c_tview3d_getlongitude
        getPsi = xform0 c_tview3d_getpsi
        isViewChanged = xform0 c_tview3d_isviewchanged
        rotateView = xform2 c_tview3d_rotateview
        setLatitude = xform1 c_tview3d_setlatitude
        setLongitude = xform1 c_tview3d_setlongitude
        setPsi = xform1 c_tview3d_setpsi
        setView1 = xform4 c_tview3d_setview1
        setViewChanged = xform1 c_tview3d_setviewchanged
        side = xform0 c_tview3d_side
        sideView = xform1 c_tview3d_sideview
        top = xform0 c_tview3d_top
        topView = xform1 c_tview3d_topview

instance () => ITObject (TView3D) where
        clear = xform1 c_tview3d_clear
        draw = xform1 c_tview3d_draw
        findObject = xform1 c_tview3d_findobject
        getName = xform0 c_tview3d_getname
        isA = xform0 c_tview3d_isa
        paint = xform1 c_tview3d_paint
        printObj = xform1 c_tview3d_printobj
        saveAs = xform2 c_tview3d_saveas
        write = xform3 c_tview3d_write
        write_ = xform0 c_tview3d_write_

instance () => ITAttLine (TView3D) where
        getLineColor = xform0 c_tview3d_getlinecolor
        getLineStyle = xform0 c_tview3d_getlinestyle
        getLineWidth = xform0 c_tview3d_getlinewidth
        resetAttLine = xform1 c_tview3d_resetattline
        setLineAttributes = xform0 c_tview3d_setlineattributes
        setLineColor = xform1 c_tview3d_setlinecolor
        setLineStyle = xform1 c_tview3d_setlinestyle
        setLineWidth = xform1 c_tview3d_setlinewidth

instance () => IDeletable (TView3D) where
        delete = xform0 c_tview3d_delete
